// FullAccess
resource "azurerm_role_definition" "azure_database_for_postgresql_fullaccess_definition" {
  name              = "azure-database-for-postgresql-fullaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.DBforPostgreSQL/register/action",
      "Microsoft.DBforPostgreSQL/checkNameAvailability/action",
      "Microsoft.DBforPostgreSQL/locations/performanceTiers/read",
      "Microsoft.DBforPostgreSQL/servers/virtualNetworkRules/read",
      "Microsoft.DBforPostgreSQL/servers/virtualNetworkRules/write",
      "Microsoft.DBforPostgreSQL/servers/virtualNetworkRules/delete",
      "Microsoft.DBforPostgreSQL/servers/queryTexts/action",
      "Microsoft.DBforPostgreSQL/servers/read",
      "Microsoft.DBforPostgreSQL/servers/write",
      "Microsoft.DBforPostgreSQL/servers/delete",
      "Microsoft.DBforPostgreSQL/servers/restart/action",
      "Microsoft.DBforPostgreSQL/servers/updateConfigurations/action",
      "Microsoft.DBforPostgreSQL/performanceTiers/read",
      "Microsoft.DBforPostgreSQL/servers/firewallRules/read",
      "Microsoft.DBforPostgreSQL/servers/firewallRules/write",
      "Microsoft.DBforPostgreSQL/servers/firewallRules/delete",
      "Microsoft.DBforPostgreSQL/servers/securityAlertPolicies/read",
      "Microsoft.DBforPostgreSQL/servers/securityAlertPolicies/write",
      "Microsoft.DBforPostgreSQL/servers/recoverableServers/read",
      "Microsoft.DBforPostgreSQL/servers/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.DBforPostgreSQL/servers/providers/Microsoft.Insights/logDefinitions/read",
      "Microsoft.DBforPostgreSQL/servers/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.DBforPostgreSQL/servers/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.DBforPostgreSQL/servers/topQueryStatistics/read",
      "Microsoft.DBforPostgreSQL/servers/configurations/read",
      "Microsoft.DBforPostgreSQL/servers/configurations/write",
      "Microsoft.DBforPostgreSQL/servers/waitStatistics/read",
      "Microsoft.DBforPostgreSQL/servers/advisors/read",
      "Microsoft.DBforPostgreSQL/servers/advisors/recommendedActionSessions/action",
      "Microsoft.DBforPostgreSQL/servers/advisors/recommendedActions/read",
      "Microsoft.DBforPostgreSQL/servers/queryTexts/read",
      "Microsoft.DBforPostgreSQL/locations/securityAlertPoliciesAzureAsyncOperation/read",
      "Microsoft.DBforPostgreSQL/locations/securityAlertPoliciesOperationResults/read",
      "Microsoft.DBforPostgreSQL/locations/operationResults/read",
      "Microsoft.DBforPostgreSQL/locations/operationResults/read",
      "Microsoft.DBforPostgreSQL/locations/azureAsyncOperation/read",
      "Microsoft.DBforPostgreSQL/servers/databases/read",
      "Microsoft.DBforPostgreSQL/servers/databases/write",
      "Microsoft.DBforPostgreSQL/servers/databases/delete",
      "Microsoft.DBforPostgreSQL/servers/logFiles/read",
      "Microsoft.DBforPostgreSQL/operations/read",
      "Microsoft.DBforPostgreSQL/serversv2/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.DBforPostgreSQL/serversv2/providers/Microsoft.Insights/logDefinitions/read",
      "Microsoft.DBforPostgreSQL/serversv2/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.DBforPostgreSQL/serversv2/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.DBforPostgreSQL/serversv2/read",
      "Microsoft.DBforPostgreSQL/serversv2/write",
      "Microsoft.DBforPostgreSQL/serversv2/delete",
      "Microsoft.DBforPostgreSQL/serversv2/updateConfigurations/action",
      "Microsoft.DBforPostgreSQL/serversv2/firewallRules/read",
      "Microsoft.DBforPostgreSQL/serversv2/firewallRules/write",
      "Microsoft.DBforPostgreSQL/serversv2/firewallRules/delete",
      "Microsoft.DBforPostgreSQL/serversv2/configurations/read",
      "Microsoft.DBforPostgreSQL/serversv2/configurations/write",
      "Microsoft.DBforPostgreSQL/servers/administrators/read",
      "Microsoft.DBforPostgreSQL/servers/administrators/write",
      "Microsoft.DBforPostgreSQL/servers/administrators/delete",
      "Microsoft.DBforPostgreSQL/servers/replicas/read",
    ]

    not_actions = []
  }
}

// ReadOnly
resource "azurerm_role_definition" "azure_database_for_postgresql_readonly_definition" {
  name              = "azure-database-for-postgresql-readonly-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.DBforPostgreSQL/locations/performanceTiers/read",
      "Microsoft.DBforPostgreSQL/servers/virtualNetworkRules/read",
      "Microsoft.DBforPostgreSQL/servers/read",
      "Microsoft.DBforPostgreSQL/performanceTiers/read",
      "Microsoft.DBforPostgreSQL/servers/firewallRules/read",
      "Microsoft.DBforPostgreSQL/servers/securityAlertPolicies/read",
      "Microsoft.DBforPostgreSQL/servers/recoverableServers/read",
      "Microsoft.DBforPostgreSQL/servers/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.DBforPostgreSQL/servers/providers/Microsoft.Insights/logDefinitions/read",
      "Microsoft.DBforPostgreSQL/servers/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.DBforPostgreSQL/servers/topQueryStatistics/read",
      "Microsoft.DBforPostgreSQL/servers/configurations/read",
      "Microsoft.DBforPostgreSQL/servers/waitStatistics/read",
      "Microsoft.DBforPostgreSQL/servers/advisors/read",
      "Microsoft.DBforPostgreSQL/servers/advisors/recommendedActions/read",
      "Microsoft.DBforPostgreSQL/servers/queryTexts/read",
      "Microsoft.DBforPostgreSQL/locations/securityAlertPoliciesAzureAsyncOperation/read",
      "Microsoft.DBforPostgreSQL/locations/securityAlertPoliciesOperationResults/read",
      "Microsoft.DBforPostgreSQL/locations/operationResults/read",
      "Microsoft.DBforPostgreSQL/locations/operationResults/read",
      "Microsoft.DBforPostgreSQL/locations/azureAsyncOperation/read",
      "Microsoft.DBforPostgreSQL/servers/databases/read",
      "Microsoft.DBforPostgreSQL/servers/logFiles/read",
      "Microsoft.DBforPostgreSQL/operations/read",
      "Microsoft.DBforPostgreSQL/serversv2/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.DBforPostgreSQL/serversv2/providers/Microsoft.Insights/logDefinitions/read",
      "Microsoft.DBforPostgreSQL/serversv2/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.DBforPostgreSQL/serversv2/read",
      "Microsoft.DBforPostgreSQL/serversv2/firewallRules/read",
      "Microsoft.DBforPostgreSQL/serversv2/configurations/read",
      "Microsoft.DBforPostgreSQL/servers/administrators/read",
      "Microsoft.DBforPostgreSQL/servers/replicas/read",
    ]

    not_actions = [
      "Microsoft.DBforPostgreSQL/register/action",
      "Microsoft.DBforPostgreSQL/checkNameAvailability/action",
      "Microsoft.DBforPostgreSQL/servers/virtualNetworkRules/write",
      "Microsoft.DBforPostgreSQL/servers/virtualNetworkRules/delete",
      "Microsoft.DBforPostgreSQL/servers/queryTexts/action",
      "Microsoft.DBforPostgreSQL/servers/write",
      "Microsoft.DBforPostgreSQL/servers/delete",
      "Microsoft.DBforPostgreSQL/servers/restart/action",
      "Microsoft.DBforPostgreSQL/servers/updateConfigurations/action",
      "Microsoft.DBforPostgreSQL/servers/firewallRules/write",
      "Microsoft.DBforPostgreSQL/servers/firewallRules/delete",
      "Microsoft.DBforPostgreSQL/servers/securityAlertPolicies/write",
      "Microsoft.DBforPostgreSQL/servers/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.DBforPostgreSQL/servers/configurations/write",
      "Microsoft.DBforPostgreSQL/servers/advisors/recommendedActionSessions/action",
      "Microsoft.DBforPostgreSQL/servers/databases/write",
      "Microsoft.DBforPostgreSQL/servers/databases/delete",
      "Microsoft.DBforPostgreSQL/serversv2/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.DBforPostgreSQL/serversv2/write",
      "Microsoft.DBforPostgreSQL/serversv2/delete",
      "Microsoft.DBforPostgreSQL/serversv2/updateConfigurations/action",
      "Microsoft.DBforPostgreSQL/serversv2/firewallRules/write",
      "Microsoft.DBforPostgreSQL/serversv2/firewallRules/delete",
      "Microsoft.DBforPostgreSQL/serversv2/configurations/write",
      "Microsoft.DBforPostgreSQL/servers/administrators/write",
      "Microsoft.DBforPostgreSQL/servers/administrators/delete",
    ]
  }
}

// NoAccess
resource "azurerm_role_definition" "azure_database_for_postgresql_noaccess_definition" {
  name              = "azure-database-for-postgresql-noaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = []

    not_actions = [
      "Microsoft.DBforPostgreSQL/register/action",
      "Microsoft.DBforPostgreSQL/checkNameAvailability/action",
      "Microsoft.DBforPostgreSQL/locations/performanceTiers/read",
      "Microsoft.DBforPostgreSQL/servers/virtualNetworkRules/read",
      "Microsoft.DBforPostgreSQL/servers/virtualNetworkRules/write",
      "Microsoft.DBforPostgreSQL/servers/virtualNetworkRules/delete",
      "Microsoft.DBforPostgreSQL/servers/queryTexts/action",
      "Microsoft.DBforPostgreSQL/servers/read",
      "Microsoft.DBforPostgreSQL/servers/write",
      "Microsoft.DBforPostgreSQL/servers/delete",
      "Microsoft.DBforPostgreSQL/servers/restart/action",
      "Microsoft.DBforPostgreSQL/servers/updateConfigurations/action",
      "Microsoft.DBforPostgreSQL/performanceTiers/read",
      "Microsoft.DBforPostgreSQL/servers/firewallRules/read",
      "Microsoft.DBforPostgreSQL/servers/firewallRules/write",
      "Microsoft.DBforPostgreSQL/servers/firewallRules/delete",
      "Microsoft.DBforPostgreSQL/servers/securityAlertPolicies/read",
      "Microsoft.DBforPostgreSQL/servers/securityAlertPolicies/write",
      "Microsoft.DBforPostgreSQL/servers/recoverableServers/read",
      "Microsoft.DBforPostgreSQL/servers/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.DBforPostgreSQL/servers/providers/Microsoft.Insights/logDefinitions/read",
      "Microsoft.DBforPostgreSQL/servers/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.DBforPostgreSQL/servers/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.DBforPostgreSQL/servers/topQueryStatistics/read",
      "Microsoft.DBforPostgreSQL/servers/configurations/read",
      "Microsoft.DBforPostgreSQL/servers/configurations/write",
      "Microsoft.DBforPostgreSQL/servers/waitStatistics/read",
      "Microsoft.DBforPostgreSQL/servers/advisors/read",
      "Microsoft.DBforPostgreSQL/servers/advisors/recommendedActionSessions/action",
      "Microsoft.DBforPostgreSQL/servers/advisors/recommendedActions/read",
      "Microsoft.DBforPostgreSQL/servers/queryTexts/read",
      "Microsoft.DBforPostgreSQL/locations/securityAlertPoliciesAzureAsyncOperation/read",
      "Microsoft.DBforPostgreSQL/locations/securityAlertPoliciesOperationResults/read",
      "Microsoft.DBforPostgreSQL/locations/operationResults/read",
      "Microsoft.DBforPostgreSQL/locations/operationResults/read",
      "Microsoft.DBforPostgreSQL/locations/azureAsyncOperation/read",
      "Microsoft.DBforPostgreSQL/servers/databases/read",
      "Microsoft.DBforPostgreSQL/servers/databases/write",
      "Microsoft.DBforPostgreSQL/servers/databases/delete",
      "Microsoft.DBforPostgreSQL/servers/logFiles/read",
      "Microsoft.DBforPostgreSQL/operations/read",
      "Microsoft.DBforPostgreSQL/serversv2/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.DBforPostgreSQL/serversv2/providers/Microsoft.Insights/logDefinitions/read",
      "Microsoft.DBforPostgreSQL/serversv2/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.DBforPostgreSQL/serversv2/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.DBforPostgreSQL/serversv2/read",
      "Microsoft.DBforPostgreSQL/serversv2/write",
      "Microsoft.DBforPostgreSQL/serversv2/delete",
      "Microsoft.DBforPostgreSQL/serversv2/updateConfigurations/action",
      "Microsoft.DBforPostgreSQL/serversv2/firewallRules/read",
      "Microsoft.DBforPostgreSQL/serversv2/firewallRules/write",
      "Microsoft.DBforPostgreSQL/serversv2/firewallRules/delete",
      "Microsoft.DBforPostgreSQL/serversv2/configurations/read",
      "Microsoft.DBforPostgreSQL/serversv2/configurations/write",
      "Microsoft.DBforPostgreSQL/servers/administrators/read",
      "Microsoft.DBforPostgreSQL/servers/administrators/write",
      "Microsoft.DBforPostgreSQL/servers/administrators/delete",
      "Microsoft.DBforPostgreSQL/servers/replicas/read",
    ]
  }
}
